using System;
using Server;
using Server.Items;

namespace Server.Items
{
	public class DragonsTooth : BaseReagent, ICommodity
	{
        int ICommodity.DescriptionNumber { get { return LabelNumber; } }
        bool ICommodity.IsDeedable { get { return true; } }

		[Constructable]
		public DragonsTooth() : this( 1 )
		{
		}

		[Constructable]
		public DragonsTooth( int amount ) : base( 0xF29, amount )
		{
			Name = "Dragon Tooth";
			Weight = 1.0;
		}

		public DragonsTooth( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}
